

function createAnimationDoubleSample()
{  
    Sys.Silverlight.createObject(
        "animation-double.xaml",                      // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createAnimationEllipseSample()
{  
    Sys.Silverlight.createObject(
        "animation-ellipse.xaml",                      // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createAnimationMultipleSample()
{  
    Sys.Silverlight.createObject(
        "animation-multiple.xaml",                      // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createAnimationPointColorSample()
{  
    Sys.Silverlight.createObject(
        "animation-point-color.xaml",       // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createAnimationStoryboardSample()
{  
    Sys.Silverlight.createObject(
        "animation-storyboard.xaml",       // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createAnimationTimelinesSample()
{  
    Sys.Silverlight.createObject(
        "animation-timelines.xaml",       // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createAnimationTriggersSample()
{  
    Sys.Silverlight.createObject(
        "animation-triggers.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createCanvasAddItemSample()
{  
    Sys.Silverlight.createObject(
        "canvas-additem.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createCanvasAddItemSample()
{  
    Sys.Silverlight.createObject(
        "canvas-additem.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createCanvasChildWidthHeightSample()
{  
    Sys.Silverlight.createObject(
        "canvas-childWidthHeight.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createCanvasHeightWidthSample()
{  
    Sys.Silverlight.createObject(
        "canvas-heightWidth.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createCanvasLeftTopSample()
{  
    Sys.Silverlight.createObject(
        "canvas-LeftTop.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createCanvasNestSample()
{  
    Sys.Silverlight.createObject(
        "canvas-nested.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createControlsHyperlinkSample()
{  
    Sys.Silverlight.createObject(
        "controls-hyperlink.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createControlsSliderSample()
{  
    Sys.Silverlight.createObject(
        "controls-slider.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createDrawingColorsSample()
{  
    Sys.Silverlight.createObject(
        "drawing-Colors.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createDrawingEllipseRectangleLineSample()
{  
    Sys.Silverlight.createObject(
        "drawing-ellipseRectangleLine.xaml", // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createDrawingGradientsSample()
{  
    Sys.Silverlight.createObject(
        "drawing-Gradients.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createDrawingImageBrushSample()
{  
    Sys.Silverlight.createObject(
        "drawing-ImageBrush.xaml",          // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createDrawingPathSample()
{  
    Sys.Silverlight.createObject(
        "drawing-Path.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createDrawingPolylinePolygonSample()
{  
    Sys.Silverlight.createObject(
        "drawing-Polyline-Polygon.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createDrawingStrokeFillSample()
{  
    Sys.Silverlight.createObject(
        "drawing-Stroke-Fill.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createImageSimpleSample()
{  
    Sys.Silverlight.createObject(
        "image-simple.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createImageStretchSample()
{  
    Sys.Silverlight.createObject(
        "image-stretch.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createMediaCompositionSample()
{  
    Sys.Silverlight.createObject(
        "media-composition.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createMediaFullScreenSample()
{  
    Sys.Silverlight.createObject(
        "media-fullscreen.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createMediaMarkersSample()
{  
    Sys.Silverlight.createObject(
        "media-markers.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createMediaScriptingSample()
{  
    Sys.Silverlight.createObject(
        "media-scripting.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createMediaSimpleSample()
{  
    Sys.Silverlight.createObject(
        "media-simple.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createMediaVideoBrushSample()
{  
    Sys.Silverlight.createObject(
        "media-videobrush.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createScriptingAnimationsSample()
{  
    Sys.Silverlight.createObject(
        "scripting-animations.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createScriptingCreateSample()
{  
    Sys.Silverlight.createObject(
        "scripting-create.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createScriptingFindNameSample()
{  
    Sys.Silverlight.createObject(
        "scripting-FindName.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createScriptingGetElementByIdSample()
{  
    Sys.Silverlight.createObject(
        "scripting-getElementById.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}

function createScriptingGetSetValueSample()
{  
    Sys.Silverlight.createObject(
        "scripting-GetSetValue.xaml",                // Source property value.
        parentElement,                      // DOM reference to hosting DIV tag.
        "myControl",                        // Unique control id value.
        {                                   // Control properties.
            width:'300',                    // Width of rectangular region of control in pixels.
            height:'300',                   // Height of rectangular region of control in pixels.
            inplaceInstallPrompt:false,     // Determines whether to display in-place install prompt if invalid version detected.
            background:'#D6D6D6',           // Background color of control.
            isWindowless:'false',           // Determines whether to display control in Windowless mode.
            framerate:'24',                 // MaxFrameRate property value.
            version:'0.9'                   // Control version to use.
        },
        {
            onError:null,                   // OnError property value -- event handler function name.
            onLoad:null                     // OnLoad property value -- event handler function name.
        },
        null);                              // Context value -- event handler function name.
}


function create_canvasZOrderSample()
{  
      
    Sys.Silverlight.createObject(
         "canvas-zorder.xaml", // The file that contains your XAML content.
         parentElement, // The host element.
         "canvasZOrderSample", // The id of the object tag generated by this method.
         {
              width:'300', // The control's width.
              height:'300', // The control's height.
              inplaceInstallPrompt:false, 
              background:'#D6D6D6', 
              isWindowless:'false', 
              framerate:'24', 
              version:'0.8'
         },
         {onError:null, onLoad:null},
         null // The user context.
         );

}

function create_canvasZOrder2Sample()

{  
      
    Sys.Silverlight.createObject(
         "canvas-zorder2.xaml", // The file that contains your XAML content.
         parentElement, // The host element.
         "canvasZOrder2Sample", // The id of the object tag generated by this method.
         {
              width:'300', // The control's width.
              height:'300', // The control's height.
              inplaceInstallPrompt:false, 
              background:'#D6D6D6', 
              isWindowless:'false', 
              framerate:'24', 
              version:'0.8'
         },
         {onError:null, onLoad:null},
         null // The user context.
         );

}



function create_mediaCompositionSampleHost()

{  
      
    Sys.Silverlight.createObject(
         "media-composition.xaml", // The file that contains your XAML content.
         mediaCompositionSampleHost, // The host element.
         "mediaCompositionSample", // The id of the object tag generated by this method.
         {
              width:'300', // The control's width.
              height:'300', // The control's height.
              inplaceInstallPrompt:false, 
              background:'#D6D6D6', 
              isWindowless:'false', 
              framerate:'24', 
              version:'0.8'
         },
         {onError:null, onLoad:null},
         null // The user context.
         );

}

function create_mediaFullScreenSampleHost()

{  
      
    Sys.Silverlight.createObject(
         "media-fullscreen.xaml", // The file that contains your XAML content.
         mediaFullScreenSampleHost, // The host element.
         "mediaFullScreenSample", // The id of the object tag generated by this method.
         {
              width:'300', // The control's width.
              height:'300', // The control's height.
              inplaceInstallPrompt:false, 
              background:'#D6D6D6', 
              isWindowless:'false', 
              framerate:'24', 
              version:'0.8'
         },
         {onError:null, onLoad:null},
         null // The user context.
         );

}


function create_mediaScriptingSampleHost()

{  
      
    Sys.Silverlight.createObject(
         "media-scripting.xaml", // The file that contains your XAML content.
         mediaScriptingSampleHost, // The host element.
         "mediaScriptingSample", // The id of the object tag generated by this method.
         {
              width:'300', // The control's width.
              height:'300', // The control's height.
              inplaceInstallPrompt:false, 
              background:'#D6D6D6', 
              isWindowless:'false', 
              framerate:'24', 
              version:'0.8'
         },
         {onError:null, onLoad:null},
         null // The user context.
         );

}

function create_mediaMarkersSampleHost()

{  
      
    Sys.Silverlight.createObject(
         "media-markers.xaml", // The file that contains your XAML content.
         mediaMarkersSampleHost, // The host element.
         "mediaMarkersSample", // The id of the object tag generated by this method.
         {
              width:'300', // The control's width.
              height:'300', // The control's height.
              inplaceInstallPrompt:false, 
              background:'#D6D6D6', 
              isWindowless:'false', 
              framerate:'24', 
              version:'0.8'
         },
         {onError:null, onLoad:null},
         null // The user context.
         );

}